/**************************************************************************
*
* File:          $RCSfile: dgemv.h,v $
* Module:        BLAS function
* Part of:       Gandalf Library
*
* Revision:      $Revision: 1.2 $
* Last edited:   $Date: 2001/10/04 16:27:00 $
* Author:        $Author: pm $
* Copyright:     Modifications (c) 2000 Imagineer Software Limited
*
* Notes:         
* Private func:  
* History:       Modified from original CLAPACK source code 
*
**************************************************************************/

#ifndef _GAN_DGEMV_H
#define _GAN_DGEMV_H

#include <gandalf/common/misc_defs.h>
#include <gandalf/linalg/linalg_defs.h>

#ifdef __cplusplus
extern "C" {
#endif

/* only declare this function locally if there is no LAPACK installed */
#ifndef HAVE_LAPACK
Gan_Bool gan_dgemv ( Gan_TposeFlag trans, long m, long n, double alpha,
                     double *a, long lda, double *x, long incx, 
                     double beta, double *y, long incy );
#endif


#ifdef __cplusplus
}
#endif

#endif /* #ifndef _GAN_DGEMV_H */
